<template>
    <div :class="{ fullscreen: isStreamingSecondaryMedia }">
        <video ref="primaryVideo" class="primaryVideo" :media-stream.camel="primaryMediaStream" :muted="true" autoplay playsinline></video>
        <video ref="secondaryVideo" class="secondaryVideo" :media-stream.camel="secondaryMediaStream" :muted="true" v-show="isStreamingSecondaryMedia" autoplay playsinline></video>
        <statistics :statistics="participant.statistics" :visible="statisticsVisible"/>
        <div class="controls">
            <name class="name" :value="participant.name" @change="changeName"/>
        </div>
    </div>
</template>

<script setup>

    import { ref, computed, onBeforeUnmount } from "vue";

    import Statistics from "./Statistics.vue";
    import Name from "./Name.vue";

    const props = defineProps({
        participant: Object,
        statisticsVisible: Boolean,
    });

    const primaryVideo = ref(null);
    const secondaryVideo = ref(null);

    const emit = defineEmits(["change_name"]);

    const isStreamingSecondaryMedia = computed(() => {
        return props.participant.secondaryMediaStream != null;
    });

    const primaryMediaStream = computed(() => {
        return props.participant.primaryMediaStream;
    });

    const secondaryMediaStream = computed(() => {
        return props.participant.secondaryMediaStream;
    });

    const changeName = (name) => {
        emit("change_name", name);
    };

    onBeforeUnmount(() => {
        primaryVideo.value.mediaStream = null;
        secondaryVideo.value.mediaStream = null;
    });

</script>

<style scoped>

    .fullscreen {
        position: absolute !important;
        width: 100% !important;
        height: 100% !important;
        z-index: 1;
    }

    .primaryVideo {
        position: absolute;
        width: 100%;
        height: 100%;
        object-fit: cover;
        transform: scaleX(-1);
    }

    .secondaryVideo {
        position: absolute;
        width: 100%;
        height: 100%;
        object-fit: cover;
    }

    .controls {
        position: absolute;
        bottom: 5px;
        left: 5px;
        padding: 5px 10px;
        font-size: 1em;
        background: #212121;
        display: flex;
        flex-direction: row;
        align-items: center;
    }

</style>